%global debug_package %{nil}

# need boost static libs
# * libboost_unit_test_framework.so.1.xx.x (shared, Boost_USE_STATIC_LIBS=ON)
%bcond_with tests

Name:           robin-map
Version:        1.2.1
Release:        %mkrel 1
Summary:        C++ implementation of a fast hash map and hash set using robin hood hashing
Group:          Development/C++
License:        MIT
URL:            https://github.com/Tessil/robin-map
Source0:        https://github.com/Tessil/%{name}/archive/v%{version}/%{name}-%{version}.tar.gz
BuildArch:      noarch

BuildRequires:  cmake
BuildRequires:  gcc-c++
BuildRequires:  boost-devel

%description
The robin-map library is a C++ implementation of a fast hash map and hash set
using open-addressing and linear robin hood hashing with backward shift
deletion to resolve collisions.

*** This is a header only library. ***
The package you want is %{name}-devel.


%package devel
Summary:        C++ implementation of a fast hash map and hash set using robin hood hashing
Group:          Development/C++

%description devel
The robin-map library is a C++ implementation of a fast hash map and hash set
using open-addressing and linear robin hood hashing with backward shift
deletion to resolve collisions.

Four classes are provided: tsl::robin_map, tsl::robin_set, tsl::robin_pg_map
and tsl::robin_pg_set. The first two are faster and use a power of two growth
policy, the last two use a prime growth policy instead and are able to cope
better with a poor hash function. Use the prime version if there is a chance of
repeating patterns in the lower bits of your hash (e.g. you are storing
pointers with an identity hash function). See GrowthPolicy for details.

A benchmark of tsl::robin_map against other hash maps may be found here. This
page also gives some advices on which hash table structure you should try for
your use case (useful if you are a bit lost with the multiple hash tables
implementations in the tsl namespace).


%prep
%autosetup -p1

%build
%cmake
%cmake_build

%install
%cmake_install

%if %{with tests}
%check
pushd tests
%cmake
%cmake_build
./%{_vpath_builddir}/tsl_robin_map_tests
%endif

%files devel
%license LICENSE
%doc README.md
%{_datadir}/cmake/tsl-%{name}/*.cmake
%{_includedir}/tsl/


%changelog
* Thu Jan 12 2023 daviddavid <daviddavid> 1.2.1-1.mga9
+ Revision: 1932633
- new version: 1.2.1

* Sun Dec 04 2022 daviddavid <daviddavid> 1.0.1-1.mga9
+ Revision: 1917819
- disable testsuite which require boost-static libs now
+ neoclust <neoclust>
- New version  1.0.1

* Thu Mar 24 2022 umeabot <umeabot> 0.6.3-2.mga9
+ Revision: 1824274
- Mageia 9 Mass Rebuild

* Tue Jun 23 2020 daviddavid <daviddavid> 0.6.3-1.mga8
+ Revision: 1598599
- new version: 0.6.3

* Sun Feb 16 2020 daviddavid <daviddavid> 0.6.2-2.mga8
+ Revision: 1535267
- use new cmake macros
+ umeabot <umeabot>
- Mageia 8 Mass Rebuild

* Thu Oct 03 2019 daviddavid <daviddavid> 0.6.2-1.mga8
+ Revision: 1449044
- new version: 0.6.2

* Mon Jul 15 2019 daviddavid <daviddavid> 0.6.1-1.mga8
+ Revision: 1421552
- initial package robin-map

